Index: branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2210)
@@ -113,4 +113,8 @@
       <Name>HeuristicLab.Data-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj">
+      <Project>{924B6BEA-9A99-40FE-9334-5C01E8D540EC}</Project>
+      <Name>HeuristicLab.GP.Interfaces-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.GP.StructureIdentification\3.3\HeuristicLab.GP.StructureIdentification-3.3.csproj">
       <Project>{74223A32-C726-4978-BE78-37113A18373C}</Project>
Index: branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2210)
@@ -32,4 +32,5 @@
   [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
   [Dependency(Dependency = "HeuristicLab.GP-3.3")]
+  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
   [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification-3.3")]
   [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
Index: branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2210)
@@ -34,4 +34,5 @@
 using HeuristicLab.GP;
 using HeuristicLab.Random;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.LinearRegression {
@@ -281,5 +282,5 @@
       model.TestVarianceAccountedFor = bestModelScope.GetVariableValue<DoubleData>("TestVAF", false).Data;
 
-      model.Data = bestModelScope.GetVariableValue<IFunctionTree>("LinearRegressionModel", false);
+      model.Data = bestModelScope.GetVariableValue<IGeneticProgrammingModel>("LinearRegressionModel", false);
       HeuristicLab.DataAnalysis.Dataset ds = bestModelScope.GetVariableValue<Dataset>("Dataset", true);
       model.Dataset = ds;
Index: branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs	(revision 2210)
@@ -28,4 +28,5 @@
 using HeuristicLab.GP;
 using HeuristicLab.GP.StructureIdentification;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.LinearRegression {
@@ -38,7 +39,5 @@
       AddVariableInfo(new VariableInfo("SamplesStart", "Start index of samples in dataset to evaluate", typeof(IntData), VariableKind.In));
       AddVariableInfo(new VariableInfo("SamplesEnd", "End index of samples in dataset to evaluate", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("LinearRegressionModel", "Formula that was calculated by linear regression", typeof(IFunctionTree), VariableKind.Out | VariableKind.New));
-      AddVariableInfo(new VariableInfo("TreeSize", "The size (number of nodes) of the tree", typeof(IntData), VariableKind.New | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeHeight", "The height of the tree", typeof(IntData), VariableKind.New | VariableKind.Out));
+      AddVariableInfo(new VariableInfo("LinearRegressionModel", "Formula that was calculated by linear regression", typeof(IGeneticProgrammingModel), VariableKind.Out | VariableKind.New));
     }
 
@@ -55,8 +54,6 @@
       double[] coefficients = CalculateCoefficients(inputMatrix, targetVector);
       IFunctionTree tree = CreateModel(coefficients, allowedColumns.Select(i => dataset.GetVariableName(i)).ToList());
-
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("LinearRegressionModel"), tree));
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TreeSize"), new IntData(tree.Size)));
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TreeHeight"), new IntData(tree.Height)));
+      
+      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("LinearRegressionModel"), new GeneticProgrammingModel(tree)));
       return null;
     }
@@ -73,13 +70,13 @@
       GP.StructureIdentification.Variable v;
       for (int i = 0; i < coefficients.Length - 1; i++) {
-        var vNode = new GP.StructureIdentification.Variable().GetTreeNode();
-        vNode.GetLocalVariable(GP.StructureIdentification.Variable.INDEX).Value = new StringData(allowedVariables[i]);
-        vNode.GetLocalVariable(GP.StructureIdentification.Variable.WEIGHT).Value = new DoubleData(coefficients[i]);
-        vNode.GetLocalVariable(GP.StructureIdentification.Variable.OFFSET).Value = new ConstrainedIntData(0);
+        var vNode = (VariableFunctionTree)new GP.StructureIdentification.Variable().GetTreeNode();
+        vNode.VariableName = allowedVariables[i];
+        vNode.Weight = coefficients[i];
+        vNode.SampleOffset = 0;
         nodes.Enqueue(vNode);
       }
-      var cNode = new Constant().GetTreeNode();
+      var cNode = (ConstantFunctionTree)new Constant().GetTreeNode();
 
-      cNode.GetLocalVariable(GP.StructureIdentification.Constant.VALUE).Value = new DoubleData(coefficients[coefficients.Length - 1]);
+      cNode.Value = coefficients[coefficients.Length - 1];
       nodes.Enqueue(cNode);
 
Index: branches/GP-Refactoring-713/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs	(revision 2210)
@@ -55,5 +55,5 @@
     }
     private IRandom uniform;
-    private double[] w = new double[] {
+    private static readonly double[] w = new double[] {
       1.7290404664e-09,
       1.2680928529e-10,
@@ -185,5 +185,5 @@
       1.6030947680e-09
     };
-    private long[] k = new long[] {
+    private static readonly long[] k = new long[] {
       1991057938,
       0,
@@ -315,5 +315,5 @@
       2010539237
    };
-    private double[] f = new double[] {
+    private static readonly double[] f = new double[] {
       1.0000000000e+00,
       9.6359968185e-01,
Index: branches/GP-Refactoring-713/sources/HeuristicLab.sln
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.sln	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.sln	(revision 2210)
@@ -235,4 +235,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.LinearRegression-3.2", "HeuristicLab.LinearRegression\3.2\HeuristicLab.LinearRegression-3.2.csproj", "{B9A64475-D542-47CF-9688-735F6224F055}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.GP.Interfaces-3.3", "HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj", "{924B6BEA-9A99-40FE-9334-5C01E8D540EC}"
 EndProject
 Global
@@ -3768,4 +3770,33 @@
 		{B9A64475-D542-47CF-9688-735F6224F055}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{B9A64475-D542-47CF-9688-735F6224F055}.Visualization Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x64.ActiveCfg = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x64.Build.0 = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|Any CPU.Build.0 = Release|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x64.ActiveCfg = Release|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x64.Build.0 = Release|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x86.ActiveCfg = Release|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x86.Build.0 = Release|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -3854,4 +3885,5 @@
 		{C75532C4-765B-418E-B09B-46D36B2ABDB1} = {410732DB-725A-4824-896B-C298978343C0}
 		{B9A64475-D542-47CF-9688-735F6224F055} = {410732DB-725A-4824-896B-C298978343C0}
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC} = {410732DB-725A-4824-896B-C298978343C0}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
Index: branches/GP-Refactoring-713/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2210)
@@ -42,4 +42,5 @@
 copy "%SolutionDir%\HeuristicLab.GP\3.3\%Outdir%\HeuristicLab.GP-3.3.dll" .\plugins
 REM copy "%SolutionDir%\HeuristicLab.GP\3.4\%Outdir%\HeuristicLab.GP-3.4.dll" .\plugins
+copy "%SolutionDir%\HeuristicLab.GP.Interfaces\3.3\%Outdir%\HeuristicLab.GP.Interfaces-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.GP.Boolean\3.3\%Outdir%\HeuristicLab.GP.Boolean-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.GP.SantaFe\3.3\%Outdir%\HeuristicLab.GP.SantaFe-3.3.dll" .\plugins
